#ifndef GLOBAL_H
#define GLOBAL_H

#include <xc.h>
#include <pic16f685.h>
#include <stdint.h>

#include "irdecoder.h"

#define _XTAL_FREQ 	8000000

#define TRUE 1
#define FALSE 0
#define TBUFS 30
#define SERIAL_BUFFER_SIZE 12
#define ON 1
#define OFF 0
#define LAST_EVENT_OCCURED_TIME 5000 //5 sekund do wygaszenia wyswietlacza na kanale 0
#define SLEEP_EVENT_START 200
#define NO_CHANNELS 4 //liczba kanalow - 3 fizyczne i jeden pusty
#define CHANNEL_ZERO 0 //definicja kana?u zerowego (mute/wylaczony wyswietlacz)
#define MAX_CHANGE_STATE_TIMER (1000) //1s
#define TRUE 1
#define FALSE 0
#define MUTE_TIMER_MAX 40
#define DISP_FLASH_CHANGE MUTE_TIMER_MAX
#define FRAME_CNT_LVL 5

#define dec_counter_exec(counter, step, execution) \
    if(counter > 0) {if(counter <= step) {execution;} counter -= step;}
#define dec_counter_zero(counter) counter -= (counter > 0) ? 1 : 0
#define set_event(X) main_sm.e = X

//------------------------------------------------------------------------------
//for debug
//------------------------------------------------------------------------------
#pragma config FOSC = 4
#pragma config WDTE = 1
#pragma config BOREN = 3

//TODO: create bit field with flags instead enums
typedef enum {
    EVENT_NONE = 0, 
            IR_RCVD = 1, 
            KEY_PRESSED = 2, KEY_PULLED, KEY_P1, KEY_P2, KEY_OFF1, KEY_OFF2, 
            POST_EVENT = 8, SLEEP_EVENT
} event_t;

typedef struct {
    void (*ptr_state)(event_t);
    uint8_t current_channel;
    event_t e;
    uint8_t timer_post_event;
    uint8_t sleep_timer;
    int8_t sleep_timer_step;
    volatile uint8_t tpulse;
    volatile uint8_t ir_pulse_received : 1;
    volatile uint8_t t1_ovf : 1;
    uint8_t mute_timer;
    uint8_t frame_cnt;
} main_state_machine_t;

extern struct IR_frame_t;

typedef struct {
    IR_frame_t ir_code_each[NO_CHANNELS];
    IR_frame_t ir_code_all;
    uint8_t current_channel;
    uint8_t light_level_idx;
    uint8_t auto_sleep_mode;
} ee_record_t;

extern main_state_machine_t main_sm;
extern eeprom ee_record_t ee_record;
extern const uint8_t CHAN2MUX[NO_CHANNELS];
inline void setMux();

#endif