/* 
 * File:   led.h
 * Author: piotrek
 *
 * Created on August 2, 2016, 9:24 PM
 */
#ifndef LED_H
#define	LED_H

#include <xc.h>
#include <stddef.h>
#include <pic16f685.h>
#include <xc.h>
#include <stdint.h>
#include <stddef.h>
#include "global.h"

#define MAX_PIN_DEF 9 //liczba segmentw wyswietlacza do wysterowania
#define DISP_BUF_LDOT  7 //pozycja segmentu lewej kropy w buforze
#define DISP_BUF_RDOT  8 //pozycja segmentu prawej kropy w buforze

#define LIGHT_INTENSE 10 //wspolczynnik 1/n wypelnienia multiplexowania segm.
//#define LIGHT_LV_MIN 8
//#define LIGHT_LV_MAX 255

#define DISP_0 0
#define DISP_1 (DISP_0+1)
#define DISP_2 (DISP_1+1)
#define DISP_3 (DISP_2+1)
#define DISP_A (DISP_3+1)
#define DISP_CLEAR (DISP_A+1)

#define CHAR_DEF_NO 12 //0..9 A d //liczba zdefiniowanych znakw do pokazania na wysw 

#define BLINKT 2
#define DOT_FLASH_TIME 10
//#define LED_BLINK_TIME 500
//#define LED_BLINK_FAST_TIME (LED_BLINK_TIME/2)
//#define LED_BLINK_THREE_NUMBERS 6

#define NO_SEG 10 //liczba segmentw wy?wietlacza do wy?wietlenia

#define SEG_A_PIN 2
#define SEG_B_PIN 6    
#define SEG_C_PIN 3
#define SEG_D_PIN 4
#define SEG_E_PIN 5
#define SEG_F_PIN 1
#define SEG_G_PIN 0    
#define SEG_DOT_PIN 7

#define CHAR_A 4
#define CHAR_d 5    

#define A ((1<<SEG_A_PIN))
#define B ((1<<SEG_B_PIN))
#define C ((1<<SEG_C_PIN))
#define D ((1<<SEG_D_PIN))
#define E ((1<<SEG_E_PIN))
#define F ((1<<SEG_F_PIN))
#define G ((1<<SEG_G_PIN))
#define DT (1<<SEG_DOT_PIN)
#define N (0)

const uint8_t DISP1[] = {
    A|B|C|D|E|F|DT,    //0
    B|C|DT,            //1
    A|B|D|E|G|DT,      //2
    A|B|C|D|G|DT,      //3
    B|C|F|G|DT,        //4
    A|C|D|F|G|DT,      //5
    A|C|D|E|F|G|DT,    //6
    A|B|C|DT,          //7
    A|B|C|D|E|F|G|DT,  //8
    A|B|C|D|F|G|DT,    //9
    A|B|C|E|F|G|DT,    //A 10
    A|C|D|E|F|G|DT,    //d 11
    D|E|F|DT,           //L 12
    A|E|F|G             //F 13
};

//extern uint8_t dim;
//extern uint8_t disp_buf2[9];

typedef enum {
    LED_OFF=0, LED_ON
} led_state_enum_t;    
    
typedef enum {
    LED_MODE_OFF=0, LED_MODE_NORMAL, LED_MODE_BLINK, 
            LED_MODE_BLINK_FAST, LED_BLINK_THREE
} led_mode_enum_t;    

#define LIGHT_LEVELS_N 6
const uint8_t LIGHT_LEVELS[LIGHT_LEVELS_N] = {8, 16, 32, 64, 128, 240};

typedef struct {
    uint8_t disp_buf;
    uint8_t int_disp;
    
    volatile uint8_t segment_slot_counter;
    volatile uint8_t segment_selector;
    uint8_t lightLevel;
    uint8_t light_level_idx;
    uint8_t disp_val;

    uint8_t blink_disp: 1;
    uint8_t blinkDot: 1;
    uint8_t dispOn: 1;
    uint8_t dotOn: 1;
    uint8_t tmpOffDisp: 1;
    uint8_t tmpDotOn: 1;
    uint8_t dotFlash: 1;
    uint8_t dispFlash: 1;
    
    uint8_t dispMainMasq;
    
    uint8_t dotFlashTimer;
    uint8_t dispFlashTimer;
    
} disp_state_t;

extern disp_state_t ds;

inline void handle_disp (void);
void init_led (void);
void function_disp(void);
    
#endif	/* LED_H */

